Bug 533167 - Review Request: emacs-ecb - Emacs Code Browser
Summary: Review Request: emacs-ecb - Emacs Code Browser
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Ruediger Landmann
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 532739
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-11-05 13:11 UTC by Karel Klíč
Modified: 2013-03-03 22:59 UTC (History)
9 users (show)

Fixed In Version: emacs-ecb-2.40.1-0.4.cvs20101021.fc14
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-05-29 23:22:34 UTC
rlandman: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Karel Klíč 2009-11-05 13:11:58 UTC
Spec URL: http://kklic.fedorapeople.org/emacs-ecb.spec
SRPM URL: http://kklic.fedorapeople.org/emacs-ecb-2.40-1.fc11.src.rpm

Description: 
ECB stands for "Emacs Code Browser". It displays a number of informational 
windows that allow for easy source code navigation and overview.

The informational windows can contain:
  * A directory tree,
  * a list of source files in the current directory
  * a list of functions/classes/methods in the current file
  * a history of recently visited files,
  * a direct and auto-updated ecb-window for the semantic-analyzer 
    for some intellisense,
  * the Speedbar and
  * output from compilation and other modes like help, grep etc. or 
    whatever a user defines to be displayed in this window. 

This package contains the files for the GNU Emacs package. 
XEmacs ECB package is a part of xemacs-packages-extra.

Requires emacs-cedet: https://bugzilla.redhat.com/show_bug.cgi?id=532739

rpmlint Output
--------------
rpmlint emacs-ecb-2.40-1.fc11.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

rpmlint ./emacs-ecb-2.40-1.fc11.noarch.rpm 
emacs-ecb.noarch: W: file-not-utf8 /usr/share/info/ecb.info-2.gz
emacs-ecb.noarch: W: file-not-utf8 /usr/share/info/ecb.info-1.gz
emacs-ecb.noarch: W: file-not-utf8 /usr/share/info/ecb.info-3.gz
emacs-ecb.noarch: W: file-not-utf8 /usr/share/doc/emacs-ecb-2.40/NEWS
1 packages and 0 specfiles checked; 0 errors, 4 warnings.

Is it necessary to patch these files?

rpmlint ./emacs-ecb-el-2.40-1.fc11.noarch.rpm 
emacs-ecb-el.noarch: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

Comment 1 Siddhesh Poyarekar 2010-01-30 20:16:40 UTC
I'm not a sponsor/provenpackager, so this is an unofficial review:

* use %global instead of %define

http://fedoraproject.org/wiki/Packaging/Guidelines#.25global_preferred_over_.25define

* The following is not required since info is considered part of the minimal build environment:

> Requires(post): /sbin/install-info
> Requires(preun): /sbin/install-info

http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

* make should have %{?_smp_mflags}. If the package fails to build due to this, you need to put in a comment mentioning that

http://fedoraproject.org/wiki/Packaging/Guidelines#Parallel_make

Comment 2 Mamoru TASAKA 2010-01-31 12:16:33 UTC
(In reply to comment #1)
> * The following is not required since info is considered part of the minimal
> build environment:
> 
> > Requires(post): /sbin/install-info
> > Requires(preun): /sbin/install-info
> 
> http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

- This wiki item says about BuildRequires, while this /sbin/install-info
  is for Requires.

Comment 3 Karel Klíč 2010-02-02 13:45:02 UTC
Thanks for the suggestions.

Spec URL: http://kklic.fedorapeople.org/emacs-ecb.spec
SRPM URL: http://kklic.fedorapeople.org/emacs-ecb-2.40-2.fc13.src.rpm

* Tue Feb  2 2010 Karel klic <kklic@redhat.com> - 2.40-2
- Used %%global instead of %%define
- Added %%{?_smp_mflags} to make call

Comment 4 Mamoru TASAKA 2010-02-17 17:03:29 UTC
So what can we do for this review request for now?

Comment 5 Karel Klíč 2010-02-17 17:18:36 UTC
We should wait until a new version of Emacs is released. The new version will contain CEDET library, which required by ECB, and should be released in March.

Comment 6 Karel Klíč 2010-05-05 14:19:25 UTC
ECB 2.40.1 will support Emacs 23.2
ECB 2.40 fails to build with it.

Comment 7 Jason Tibbitts 2010-11-13 20:21:55 UTC
So, half a year later, can this move forward or not?

Comment 8 Karel Klíč 2010-11-15 18:25:07 UTC
I have a package with the latest CVS code. It works with Emacs 23.2, but it contains several very visible bugs.

Spec URL: http://kklic.fedorapeople.org/emacs-ecb.spec
SRPM URL: http://kklic.fedorapeople.org/emacs-ecb-2.40-0.1.cvs20101021.fc12.src.rpm

I or someone else should look into fixing the most obvious flaws. It shouldn't be too difficult.

Comment 9 Jason Tibbitts 2010-11-16 16:44:12 UTC
I'm not sure if you're indicating that this is ready for review or not.  Did you want to wait until those flaws are worked out?

While I'm looking, you have inconsistent macro usage in your spec.  If you really like needless typing and actually want to use things like "%{__install}" instead of just "install", you must also use "%{__rm}" and "%{__make}".  Or just contemplate readability and sanity and get rid of the line noise.

Finally, the srpm above fails to build for me:

+ /bin/mkdir -p /builddir/build/BUILDROOT/emacs-ecb-2.40-0.1.cvs20101021.fc14.x86_64/usr/share/info
+ /usr/bin/install -m 644 info-help/ecb.info /builddir/build/BUILDROOT/emacs-ecb-2.40-0.1.cvs20101021.fc14.x86_64/usr/share/info
/usr/bin/install: cannot stat `info-help/ecb.info': No such file or directory

Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=2604528

Please clear the whiteboard if providing a package which builds.  If you think this package is not yet ready for review, you are welcome to add "NotReady" to the whiteboard.

Comment 10 Karel Klíč 2010-11-19 14:44:30 UTC
Jason, I have fixed the build problem, thank you. I'd prefer to see that some ECB bugs are fixed before importing it to Fedora, so I'm marking the review NotReady.

Someone might want to help and fix some issues, or I'll do it myself eventually (in a month or two), but I am not so much proficient in Elisp. 

Spec URL: http://kklic.fedorapeople.org/emacs-ecb.spec
SRPM URL: http://kklic.fedorapeople.org/emacs-ecb-2.40-0.2.cvs20101021.fc12.src.rpm

* Fri Nov 19 2010 Karel Klic <kklic@redhat.com> - 2.40.1-0.2.cvs20101021
- Added texinfo to build requirements

Comment 11 tuxdna 2010-12-10 07:07:13 UTC
Karel,

I built this package ( using rpmbuild ) and it works for me on Fedora 14 - x86_64.
I haven't noticed any issues as till now on my system.

How can someone locate the issues you just mentioned ( to be fixed in Elisp ) ?

Also that the bug status says that package is NotReady in the "Whiteboard" field,
so it can't be reviewed.

Comment 12 Karel Klíč 2011-01-24 16:45:54 UTC
Yes, thanks, it also works for me on Fedora 14 -- removing the NotReady tag.

I have prepared a new version.

Spec URL: http://kklic.fedorapeople.org/emacs-ecb.spec
SRPM URL: http://kklic.fedorapeople.org/emacs-ecb-2.40-0.3.cvs20101021.fc13.src.rpm

* Mon Jan 24 2011 Karel Klic <kklic@redhat.com> - 2.40.1-0.3.cvs20101021
- Removed BuildRoot tag
- Used mkdir, install instead of %%{__mkdir_p}, %%{__install}
- Do not install docs into build root
- Removed %%clean section
- Replaced local %%{emacs_*} macros with global ones
- Improved description

Comment 13 Ruediger Landmann 2011-02-03 05:23:46 UTC
Thanks Karel!

Package builds fine locally and on Koji, but rpmlint is noisy:

$ rpmlint SPECS/emacs-ecb.spec 
SPECS/emacs-ecb.spec: W: invalid-url Source0: ecb-cvs20101021.tar.xz
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

* Expected. Spec includes instructions to obtain source from upstream CVS.

$ rpmlint SRPMS/emacs-ecb-2.40-0.3.cvs20101021.fc14.src.rpm
emacs-ecb.src: W: spelling-error %description -l en_US xemacs -> XEmacs
emacs-ecb.src: W: invalid-url Source0: ecb-cvs20101021.tar.xz
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

* "xemacs" is fine here; it's in a package name.

$ rpmlint RPMS/noarch/emacs-ecb-2.40-0.3.cvs20101021.fc14.noarch.rpm
emacs-ecb.noarch: W: unexpanded-macro dependency emacs(bin) >= %{emacs_version} %{emacs_version}
emacs-ecb.noarch: W: spelling-error %description -l en_US xemacs -> XEmacs
emacs-ecb.noarch: W: incoherent-version-in-changelog 2.40.1-0.3.cvs20101021 ['2.40-0.3.cvs20101021.fc14', '2.40-0.3.cvs20101021']
emacs-ecb.noarch: W: file-not-utf8 /usr/share/info/ecb.info-2.gz
emacs-ecb.noarch: W: file-not-utf8 /usr/share/info/ecb.info-1.gz
emacs-ecb.noarch: W: file-not-utf8 /usr/share/info/ecb.info-3.gz
emacs-ecb.noarch: W: file-not-utf8 /usr/share/doc/emacs-ecb-2.40/NEWS
1 packages and 0 specfiles checked; 0 errors, 7 warnings.

* Typo in macro; should be %{_emacs_version}
* Version: should be 2.40.1 per the included Release Notes
* Please change encodings to UTF-8. Refer to: https://fedoraproject.org/wiki/PackageMaintainers/PackagingTricks#Convert_encoding_to_UTF-8

$ rpmlint RPMS/noarch/emacs-ecb-el-2.40-0.3.cvs20101021.fc14.noarch.rpm
emacs-ecb-el.noarch: W: spelling-error Summary(en_US) Elisp -> Elis, Lisp, Elise
emacs-ecb-el.noarch: W: spelling-error %description -l en_US elisp -> lisp, e lisp, Elise
emacs-ecb-el.noarch: W: no-documentation

* OK

Please fix the above issues and build a new SRPM.

Cheers
Rudi

Comment 14 Karel Klíč 2011-03-28 11:41:39 UTC
Ruediger, thank you. I have fixed the issues you pointed out.

Spec URL: http://kklic.fedorapeople.org/emacs-ecb.spec
SRPM URL: 
http://kklic.fedorapeople.org/emacs-ecb-2.40.1-0.4.cvs20101021.fc14.src.rpm

* Mon Mar 28 2011 Karel Klic <kklic@redhat.com> - 2.40.1-0.4.cvs20101021
- Fixed version tag (2.40 -> 2.40.1)
- Fixed typo in macro _emacs_version
- Removed `rm -rf %%{buildroot}` from %%install section
- Converted NEWS and ecb.texi to UTF-8
- Added emacs-ecb-requires.patch to properly include semantic in
  ecb-semantic-wrapper.el

Comment 15 Ruediger Landmann 2011-03-30 06:43:16 UTC
Thanks Karel -- Looks good now. 

ACCEPT

 - = N/A
 / = Check
 ! = Problem
 ? = Not evaluated

=== REQUIRED ITEMS ===
 [/] Rpmlint output is clean:
$ rpmlint SPECS/emacs-ecb.spec 
SPECS/emacs-ecb.spec: W: invalid-url Source0: ecb-cvs20101021.tar.xz
0 packages and 1 specfiles checked; 0 errors, 1 warnings.
$ rpmlint SRPMS/emacs-ecb-2.40.1-0.4.cvs20101021.fc14.src.rpm
emacs-ecb.src: W: spelling-error %description -l en_US xemacs -> XEmacs
emacs-ecb.src: W: invalid-url Source0: ecb-cvs20101021.tar.xz
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
$ rpmlint RPMS/noarch/emacs-ecb-2.40.1-0.4.cvs20101021.fc14.noarch.rpm
emacs-ecb.noarch: W: spelling-error %description -l en_US xemacs -> XEmacs
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
$ rpmlint RPMS/noarch/emacs-ecb-el-2.40.1-0.4.cvs20101021.fc14.noarch.rpm
emacs-ecb-el.noarch: W: spelling-error Summary(en_US) Elisp -> Elis, Lisp, Elise
emacs-ecb-el.noarch: W: spelling-error %description -l en_US elisp -> lisp, e lisp, Elise
emacs-ecb-el.noarch: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

 [/] Package is named according to the Package Naming Guidelines.
 [/] Spec file name must match the base package %{name}, in the format
%{name}.spec.
 [/] Package meets the Packaging Guidelines including the Language specific
items
 [/] Package is licensed with an open-source compatible license and meets other
legal requirements as defined in the legal section of Packaging Guidelines.
 [/] License field in the package spec file matches the actual license.
     License type: GPLv2+
 [-] If (and only if) the source package includes the text of the license(s) in
its own file, then that file, containing the text of the license(s) for the
package is included in %doc.
 [/] Spec file is legible and written in American English.
 [/] Sources used to build the package matches the upstream source, as provided
in the spec URL.
* instructions in spec file produce tarball with functionally identical contents

 [/] Package successfully compiles and builds into binary rpms on at least one
supported architecture.
     Tested: http://koji.fedoraproject.org/koji/taskinfo?taskID=2959219
 [/] Package is not known to require ExcludeArch
 [] All build dependencies are listed in BuildRequires, except for any that
are listed in the exceptions section of Packaging Guidelines.
 [-] The spec file handles locales properly (with the %find_lang macro)
 [-] ldconfig called in %post and %postun if required.
 [/] Package does not bundle copies of system libraries
 [/] Package is not relocatable.
 [/] Package must own all directories that it creates.
 [/] Package does not contain duplicates in %files.
 [/] Permissions on files are set properly
 [/] %files section includes a %defattr(...) line
 [/] Package consistently uses macros.
 [-] Large documentation files are in a -doc subpackage, if required.
 [/] Package uses nothing in %doc for runtime.
 [-] Header files in -devel subpackage, if present.
 [-] Static libraries in -static subpackage, if present.
 [-] Development .so files in -devel subpackage, if present.
 [-] -devel packages require base package with full versioning.
 [/] Package does not contain any libtool archives (.la).
 [-] Package contains a properly installed %{name}.desktop file if it is a GUI
application.
 [/] Package does not own files or directories owned by other packages.
 [/] Filenames are valid UTF-8

Comment 16 Karel Klíč 2011-05-20 13:41:06 UTC
Thank you for the review, I'm glad for it.

Comment 17 Karel Klíč 2011-05-20 13:42:04 UTC
New Package SCM Request
=======================
Package Name: emacs-ecb
Short Description: Emacs Code Browser
Owners: kklic
Branches: f14 f15
InitialCC:

Comment 18 Kevin Fenzi 2011-05-20 22:24:43 UTC
Git done (by process-git-requests).

Comment 19 Fedora Update System 2011-05-23 09:41:29 UTC
emacs-ecb-2.40.1-0.4.cvs20101021.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/emacs-ecb-2.40.1-0.4.cvs20101021.fc14

Comment 20 Fedora Update System 2011-05-23 09:41:39 UTC
emacs-ecb-2.40.1-0.4.cvs20101021.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/emacs-ecb-2.40.1-0.4.cvs20101021.fc15

Comment 21 Fedora Update System 2011-05-25 02:49:40 UTC
emacs-ecb-2.40.1-0.4.cvs20101021.fc14 has been pushed to the Fedora 14 testing repository.

Comment 22 Fedora Update System 2011-05-29 23:22:24 UTC
emacs-ecb-2.40.1-0.4.cvs20101021.fc15 has been pushed to the Fedora 15 stable repository.

Comment 23 Fedora Update System 2011-06-09 00:04:15 UTC
emacs-ecb-2.40.1-0.4.cvs20101021.fc14 has been pushed to the Fedora 14 stable repository.


Note You need to log in before you can comment on or make changes to this bug.